/*---------------------------------------------------------------------------
Program :		LxCheckBox.cpp	Version 1.1
Author :		Michel Leunen
Email :		michel@leunen.com
Date :		30/05/1999
Description :	A Linux like CheckBox
//---------------------------------------------------------------------------*/
#include <vcl\vcl.h>
#include <windows.h>
#pragma hdrstop

#include "LxCheckBox.h"
//---------------------------------------------------------------------------
static inline TLxCheckBox *ValidCtrCheck()
{
	return new TLxCheckBox(NULL);
}
//---------------------------------------------------------------------------
__fastcall TLxCheckBox::TLxCheckBox(TComponent* Owner)
	: TGraphicControl(Owner)
{
 	ControlStyle=ControlStyle<<csClickEvents<<csCaptureMouse<<csFixedWidth<<csFixedHeight;
   Width=10;
   Height=10;
   FCBDown=false;
   FPoints[0]=Point(0,0);
   FPoints[1]=Point(Width,0);
   FPoints[2]=Point(Width,Height);
   FPoints[3]=Point(0,Height);
   FRgn=CreatePolygonRgn(FPoints,4,ALTERNATE);
}
//---------------------------------------------------------------------------
__fastcall TLxCheckBox::~TLxCheckBox()
{
  	DeleteObject(FRgn);
}
//---------------------------------------------------------------------------
namespace Lxcheckbox
{
	void __fastcall Register()
	{
		TComponentClass classes[1] = {__classid(TLxCheckBox)};
		RegisterComponents("Leunen", classes, 0);
	}
}
//---------------------------------------------------------------------------
void __fastcall TLxCheckBox::Paint()
{
   RECT CBRect={0,0,10,10};

	TGraphicControl::Paint();


   if(!FCBDown)									//CheckBox up
   {
   	Canvas->Brush->Color=clLtGray;
      FillRect(Canvas->Handle,&CBRect,Canvas->Brush->Handle);
      DrawEdge(Canvas->Handle,&CBRect,
      			BDR_RAISEDINNER|BDR_RAISEDOUTER,
               BF_RECT);
   }
   else                          			//CheckBox down
   {
   	Canvas->Brush->Color=clDkGray;
      FillRect(Canvas->Handle,&CBRect,Canvas->Brush->Handle);
      DrawEdge(Canvas->Handle,&CBRect,
      			BDR_SUNKENINNER|BDR_SUNKENOUTER,
               BF_RECT);
   }
}
//---------------------------------------------------------------------------
void __fastcall TLxCheckBox::WMButtonUp(Messages::TWMMouse &Message)
{
   if(PtInRegion(FRgn,Message.XPos,Message.YPos))
   {
		FCBDown=!FCBDown;
      Paint();
   }
   TGraphicControl::Dispatch(&Message);
}
//---------------------------------------------------------------------------
void __fastcall TLxCheckBox::Click()
{
	TGraphicControl::Click();
   if(OnClick)OnClick(this);
}
//---------------------------------------------------------------------------
